#include <QApplication>
#include <QLabel>
#include <QSplashScreen>
#include <QPainter>
#include <QTime>

static const int LOAD_TIME_MSEC = 5 * 1000;

static const int PROGRESS_X_PX = 272;
static const int PROGRESS_Y_PX = 333;
static const int PROGRESS_WIDTH_PX = 310;
static const int PROGRESS_HEIGHT_PX = 28;

int main( int argc, char* argv[] ) {
    QApplication a( argc, argv );

    QPixmap pix( ":/images/splash.png" );
    QSplashScreen splashScreen( pix );
    splashScreen.show();
    a.processEvents();

    QTime time;
    time.start();
    while( time.elapsed() < LOAD_TIME_MSEC ) {
        const int progress = static_cast< double >( time.elapsed() ) / LOAD_TIME_MSEC * 100.0;
        splashScreen.showMessage( QObject::trUtf8( "Загружено: %1%" ).arg( progress ), Qt::AlignBottom | Qt::AlignRight );

        QPainter painter;
        painter.begin( &pix );

        painter.fillRect( PROGRESS_X_PX, PROGRESS_Y_PX, progress / 100.0 * PROGRESS_WIDTH_PX, PROGRESS_HEIGHT_PX, Qt::gray );

        painter.end();

        splashScreen.setPixmap( pix );
        a.processEvents();
    }

    QLabel w;
    w.resize( 200, 200 );
    w.setText( QObject::trUtf8( "Приложение запущено!" ) );
    w.setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
    w.show();

    splashScreen.finish( &w );

    return a.exec();
}
